diff --git a/src/backend/storage/freespace/freespace.c b/src/backend/storage/freespace/freespace.c
index d3f207b854..285936fd87 100644
--- a/src/backend/storage/freespace/freespace.c
+++ b/src/backend/storage/freespace/freespace.c
@@ -1175,5 +1175,11 @@ fsm_local_search(void)
 			return target_block;
 	} while (target_block > 0);
 
+	/*
+	 * If we didn't find any block in the local map, then clear it.  This
+	 * prevents us to use the map again without setting it first.
+	 */
+	FSMClearLocalMap();
+
 	return InvalidBlockNumber;
 }
